/************************************/
/* Prvni projekt z PG               */
/* Plotove vyplnovani               */
/* Autor: Martin KOSTURIK     @1998 */
/* L95289                           */
/************************************/

#include <dos.h>
#include <stdio.h>
#include <graphics.h>
#include <conio.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>

#define   AX     rg.x.ax                /* definovani registru    */
#define   BX     rg.x.bx
#define   CX     rg.x.cx
#define   DX     rg.x.dx
#define   INT    int86(0x33, &rg, &rg)  /* preruseni ovladace mysi */

typedef struct {int x, y;} bod;
bod *body_oblasti = NULL;//{{5, 5}, {150, 60}, {100, 76}, {5,5}};
int pocet_bodu;

int  reset(void);
void en(void);
void dis(void);
void rangex(int min_x, int max_x);
void rangey(int min_y, int max_y);
int  status(int button_mask, int *x, int *y);
void zadani_bodu(void);
void vyplneni(void);
int x_maximum(void);
void cara(int n, int barva);


void main(void)
{
	int i, n, mx, my, key;
	int graph_driver = DETECT, graph_mode = VGAHI, grchyba;

	grchyba = registerbgidriver(EGAVGA_driver);
	if(grchyba < 0) {
		printf("\nChyba grafiky: %s", grapherrormsg(grchyba));
		exit(1);
	}
	initgraph(&graph_driver,&graph_mode, "");

	if(!reset()) {					/* inicializace ovladace mysi*/
		printf("\nDriver mysi neni nainstalovan !");
		_setcursortype(_NORMALCURSOR);            /* zapnuti kurzoru */
		exit(1);
	}
	rangex(20, 625);
	rangey(20, 459);

    setwritemode(1);
	_setcursortype(_NOCURSOR);      			/* inicializace GUI */
	cleardevice();
	setbkcolor(BLACK);
	setfillstyle(SOLID_FILL, RED);
	bar(0, 0, 19, 479);
	bar(19, 0, 540, 19);
	bar(19, 460, 540, 479);
	bar(540, 0, 639, 479);
	settextstyle(DEFAULT_FONT, HORIZ_DIR, 1);
	settextjustify(CENTER_TEXT, CENTER_TEXT);
	setcolor(YELLOW);
	outtextxy(290, 10, "PLOTOVE VYPLNOVANI OBLASTI");
	outtextxy(590, 50, "Martin");
	outtextxy(590, 60, "KOSTURIK");
	outtextxy(590, 70, "@1998");
	ellipse(590, 140, 0, 360, 30, 15);
	ellipse(590, 190, 0, 360, 30, 15);
	ellipse(590, 240, 0, 360, 30, 15);
	setcolor(WHITE);
	outtextxy(590, 140, "Start");
	outtextxy(590, 190, "Smaz");
	outtextxy(590, 240, "Konec");
	outtextxy(290, 470, "Klikni na 'Start' ...");
	setviewport(20, 20, 539, 479, 1);

	en();                            		/* zobrazeni kurzoru mysi */

	while(1) {

		if(kbhit()) {
			key = getch();
			if(key == 'q' || key == 'Q') 		/* ukonceni klavesou 'Q'*/
				break;
		}

		i = status(3, &mx, &my);                /* cteni pozice mysi */

		if(i == 1 && mx > 530) {
			if(my > 105 && my < 135) {         /* button Start */
				bar(0, 440, 519, 459);
				outtextxy(270, 450, "Pomoci mysi zadej uzavrenou oblast.");
				pocet_bodu = 0;
				zadani_bodu();
				dis();
				vyplneni();
                en();
				bar(0, 440, 519, 459);
				free(body_oblasti);
				body_oblasti = NULL;
            }
			if(my > 155 && my < 185) {         /* button Smaz */
				clearviewport();
				bar(0, 440, 519, 459);
			}
			if(my > 205 && my < 235) break;    /* button Konec */
		}
	}

	dis();                           /* skryje kurzor mysi           */
	cleardevice();
	closegraph();                    /* ukonceni grafickeho modu  */
	_setcursortype(_NORMALCURSOR);            /* zapnuti kurzoru */
return;
}

int reset(void)
{
	 union REGS   rg;          /* Reset genius mouse driveru        */
	 AX = 0;
	 INT;                      /* zisteni zda je driver nainstalovan */
	 return AX;
}

/*             Povoleni zobrazeni kurzoru mysi                    */
void en(void)
{
	 union REGS   rg;
	 AX = 1;
	 INT;
return;
}

/*               Zakaz zobrazeni kurzoru mysi                      */
void dis(void)
{
	 union REGS   rg;
	 AX = 2;
	 INT;
return;
}

/*       Nastaveni rozsahu pohybu kurzoru v x-ov ose             */
void rangex(int min_x, int max_x)
{
	 union REGS   rg;

	 CX = min_x;
	 DX = max_x;
	 AX = 7;
	 INT;
return;
}

/*       Nastaveni rozsahu pohybu kurzoru v y-ove ose             */
void rangey(int min_y, int max_y)
{
	 union REGS   rg;

	 CX = min_y;
	 DX = max_y;
	 AX = 8;
	 INT;
return;
}

/*   Cteni stavu mysi, t.j. polohy kurzoru a stlaceni tlacitek  */
int status(int button_mask, int *x, int *y)
{
	union REGS	rg;

	AX = 3;
	BX = button_mask;                     /* bitova maska tlacitek */
	INT;
	*x = CX - 20;                         /* aktualni souradnice x a y */
	*y = DX - 20;                         /* minus 20 => 'setviewport' */
	if(*x > 519) {
		gotoxy(72, 24);
		printf("      ");
		gotoxy(72, 25);
		printf("      ");
	}
	else	{
		gotoxy(72, 24);
		printf("X=%4d", *x);
		gotoxy(72, 25);
		printf("Y=%4d", *y);
	}
return BX;
}

void zadani_bodu(void)
{
	int i, n, mx, my;
	char number[3];
    number[2] = '/0';

	rangex(20, 539);
	delay(300);
	while(1) {
		i = status(3, &mx, &my);
		if(i == 1) {
			dis();
			body_oblasti = (bod *) realloc(body_oblasti, (pocet_bodu + 1) * sizeof(bod));
			if(pocet_bodu > 2 && abs(body_oblasti[0].x - mx) < 10 &&  abs(body_oblasti[0].y - my) < 10) {
				body_oblasti[pocet_bodu] = body_oblasti[0];
				cara(pocet_bodu, YELLOW);
				break;
			}
			putpixel(mx, my, WHITE);         /* kresleni bodu */
			setcolor(LIGHTGREEN);
			circle(mx, my, 4);
			setcolor(WHITE);
			sprintf(number,"%d", pocet_bodu + 1);
			outtextxy(mx - 10,my - 10, number);
			body_oblasti[pocet_bodu].x = mx;
			body_oblasti[pocet_bodu].y = my;
			delay(300);
			cara(pocet_bodu, YELLOW);
		}
		if( i == 2 && pocet_bodu > 2) {
			body_oblasti[pocet_bodu] = body_oblasti[0];
			cara(pocet_bodu, YELLOW);
			break;
		}
	}
	rangex(20, 625);

return;
}


void vyplneni(void)
{
	int i, one, x, y, x_max;
	double t;
	bod AB;

	x_max = x_maximum();

	for(i = 0; i < 3; ++i)
		putpixel(body_oblasti[i].x, body_oblasti[i].y, WHITE);
	setcolor(YELLOW);
	for(i = 0;i < (pocet_bodu - 1); ++i) {
		AB.x = body_oblasti[i + 1].x - body_oblasti[i].x;
		AB.y = body_oblasti[i + 1].y - body_oblasti[i].y;
		if(body_oblasti[i].y < body_oblasti[i + 1].y)
				one = 0;
		else	one = 1;
		for(y = body_oblasti[i + one].y; y < body_oblasti[i - one + 1].y; ++y) {
			t = ((double) y - (double) body_oblasti[i].y) / (double) AB.y;
			x = (double) AB.x * t + body_oblasti[i].x;
			line(x, y, x_max, y);
		}
	}
return;
}


int x_maximum(void)
{
	int i, n, max, c;

	max = body_oblasti[0].x;
	for(i = 1; i < (pocet_bodu - 1); ++i)
		{
		if (body_oblasti[i].x > max)
			max = body_oblasti[i].x;
		}

return(max);
}


void cara(int n, int barva)
{
	if(pocet_bodu > 0) {
		setcolor(barva);
		moveto(body_oblasti[n-1].x, body_oblasti[n-1].y);
		lineto(body_oblasti[n].x, body_oblasti[n].y);
	}
	++pocet_bodu;
	en();
}